#%% variables are created by assignment
v=3
print(type(v))
#%% data type is defined dynamically
v=3.0
print(type(v))
#%% numpy is the liberary for linear algebra which contains array and matrix data types
import numpy as np
# you need np.array() otherwise it becomes a list
r=np.array([1,2,3,4])
print(r.ndim)
print(r.shape)
# throws an error if the condition is false
assert(len(r.shape)==r.ndim)

#%%
# not what you expect

r.T
np.transpose(r)

print(np.shape(r))
print(np.shape(r.T))
print(np.shape(np.transpose(r)))

# transpose reverses the order of dimensions, here we only have 1
r[np.newaxis,:]
r[np.newaxis,:].T

print(np.shape(r[np.newaxis,:]))
print(np.shape(r[np.newaxis,:].T))


#%% declare a column vector
c=np.array([[1],[2],[3],[4]])
print(c.ndim)
print(c.shape)
assert(len(c.shape)==c.ndim)
#%% deines a vector from 1 to 10 having step 2
a=np.arange(1,10,2)
# implicitly use step 1
a=np.arange(1,10)

#%% declare a matrix as a vector of vectors
v=np.array([[1,2,5,6],[3,4,5,6],[3,4,5,6]])
print(v)
print(v.ndim)
print(v.shape)
assert(len(v.shape)==v.ndim)

#%% array concatenation
# use horizontal stack to concatenate arrays
B=np.hstack((v,v))
print(B)
# use vertical stack
C=np.vstack((v,v))
print(C)

# not allowed: dimensions have to be consistent
np.hstack((r,c))
# not allowed: dimensions have to be consistent
np.hstack((c,c.T))

#%% array indexing and slicing

# define a matrix: you need np.array() otherwise it becomes a list
my_matrix = np.array([[1,2,3,4],[5,6,7,8],[9,10,11,12]]);
print(my_matrix)
# access the element on the third row, second column
print(my_matrix[2,1])
my_matrix[2,1] = my_matrix[2,1] * 2

#slicing, extract a whole row
print("First row as 1-dim array:", my_matrix[0,:])
#slicing, extract a whole column (watch out: it becomes a row array)
print("Second column as 1-dim array:", my_matrix[:,1])
print("Some columns:")
print(my_matrix[:,1:5])
print("Or equivalently:")
print(my_matrix[:,1:])

#%% it is not possible to exceed array bounds
my_matrix[4,0]
# not even for an assignment (in contrast with Matlab :( )
my_matrix[4,0]=2

#%% other examples of slicing
my_matrix[0:3,2:5]
my_matrix[:3,2:5]

my_matrix[0:3,[1,3]]

#%% a few dirty tricks
# last row
my_matrix[-1,:]

# second-last column (in a row vector)
my_matrix[:, -2]
# second-last column (in a column vector)
my_matrix[:, [-2]]

# unroll the image row-by-row (different from Matlab v(:) which is column-wise)
my_vector = my_matrix.flatten()

#%% Concatenate along axis
np.concatenate((my_matrix,my_matrix),axis=0)
np.concatenate((my_matrix,my_matrix),axis=1)

# invalid (axis must exist)
np.concatenate((my_matrix,my_matrix),axis=2)

# this can be also used to add a dimension to the matrix
matrix3d = np.stack((my_matrix,my_matrix), axis=0)
print(matrix3d)
print(matrix3d.shape)

# valid
matrix3d = np.stack((my_matrix,my_matrix), axis=1)
print(matrix3d)
print(matrix3d.shape)

# valid
matrix3d = np.stack((my_matrix,my_matrix), axis=2)
print(matrix3d)
print(matrix3d.shape)

#%%
# Operations are element-by-element
v*v

# do whatever you want with scalars
v*0.1
0.1*v
v+0.1

# everything is broadcasted (the smaller array is “broadcast” across the larger array so that they have compatible shapes)
# https://docs.scipy.org/doc/numpy-1.13.0/user/basics.broadcasting.html
v + np.array([0.1,0.2])
#v + np.array([0.1,0.2]).T
v + np.array([[0.1],[0.2]])

# matrix multiplication: you need to use the dot funciton in numpy
np.dot(v,v)

#%%
# operations
my_matrix
np.sum(my_matrix) # all axes
np.sum(my_matrix, axis=0) # sum along rows
np.sum(my_matrix, axis=1) # sum along cols 

# example with broadcasting: normalize columns (subtracting the mean over each row)
my_matrix-np.mean(my_matrix,axis=0)

# this does not work, 
my_matrix-np.mean(my_matrix,axis=1) # np.mean(my_matrix,axis=1) is not a column vector

# this does work, 
kk = np.mean(my_matrix,axis=1);
my_matrix-kk[np.newaxis,:].T # map it to a column vector


# another example
a = np.array([np.ones(3), np.zeros(3), np.ones(3)])
print(a)

b = a - np.mean(a, axis = 0)
print(b)

# broadcasting is done on rows 
b = a - np.mean(a, axis = 1) #np.mean(a, axis = 1) is not a column vector
print(b)

