#%% flags
import numpy as np
import matplotlib.pyplot as plt

h=200
w=300

#%% create the Italian Flag by defining an RGB image
flag = np.zeros((h,w,3))

#first third of the columns has to be green (R= 0, G = 0.5, B = 0)
flag[:, :int(w*1/3), :] = np.array([[[0.0,0.5,0.0]]])

#Second third of the columns has to be white (R=1, G = 1, B = 1)
flag[:, int(w*1/3):int(w*2/3), :] = np.array([[[1.0,1.0,1.0]]])

#Third third of the columns has to be red (R=0.8, G = 0, B = 0)
flag[:, int(w*2/3):, :] = np.array([[[0.8,0.0,0.0]]])
plt.imshow(flag)

#%% create japan flag
fig, (ax0,ax1,ax2) = plt.subplots(ncols=3, figsize=(15,5))
flag = np.zeros((h,w,3)) + 1.0

x_distancefromcenter = (np.arange(0,w)-(w/2))[np.newaxis,:]
x_distancefromcenter.shape

y_distancefromcenter = (np.arange(0,h)-(h/2))[:,np.newaxis]
y_distancefromcenter.shape

distancefromcenter = (x_distancefromcenter**2 + y_distancefromcenter**2)**0.5 # note automatic broadcasting
him = ax0.imshow((x_distancefromcenter**2 + y_distancefromcenter**2)**0.5)
plt.colorbar(him,ax=ax0)
ax0.set_title("distance from center")

flag[distancefromcenter<80,:] = np.array([[[1.0, 0, 0]]])
ax1.imshow(flag)
ax1.set_title("Flag as float values (0-1)")

flag = (flag*255).astype("ubyte")
ax2.imshow(flag)
ax2.set_title("Flag as int values (0-255)")